VERSION 5.00
Begin VB.Form frmPathTool 
   Caption         =   "Amptek PathTool"
   ClientHeight    =   6975
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   Icon            =   "PathTool.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   ScaleHeight     =   6975
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame fraApplicationPathsList 
      Caption         =   "Application Paths List"
      Height          =   4455
      Left            =   120
      TabIndex        =   14
      Top             =   120
      Width           =   4455
      Begin VB.ListBox lstSort 
         Height          =   840
         Left            =   2520
         Sorted          =   -1  'True
         TabIndex        =   5
         Top             =   2280
         Visible         =   0   'False
         Width           =   1815
      End
      Begin VB.CommandButton cmdAppPathSortList 
         Caption         =   "Sort Path List"
         Height          =   375
         Left            =   2520
         TabIndex        =   6
         Top             =   3360
         Width           =   1815
      End
      Begin VB.ListBox lstAppPathKeys 
         Height          =   3570
         Left            =   120
         MultiSelect     =   2  'Extended
         TabIndex        =   0
         Top             =   240
         Width           =   2295
      End
      Begin VB.TextBox txtAppPath 
         Height          =   495
         Left            =   120
         MultiLine       =   -1  'True
         ScrollBars      =   2  'Vertical
         TabIndex        =   7
         Top             =   3840
         Width           =   4215
      End
      Begin VB.ListBox lstAppPaths 
         Height          =   1815
         Left            =   4320
         TabIndex        =   15
         Top             =   240
         Visible         =   0   'False
         Width           =   135
      End
      Begin VB.CommandButton cmdAppPathAddFiles 
         Caption         =   "Add Files"
         Height          =   375
         Left            =   2520
         TabIndex        =   1
         Top             =   240
         Width           =   1815
      End
      Begin VB.CommandButton cmdAppPathRemoveFiles 
         Caption         =   "Remove Files"
         Height          =   375
         Left            =   2520
         TabIndex        =   2
         Top             =   720
         Width           =   1815
      End
      Begin VB.CommandButton cmdAppPathRefreshList 
         Caption         =   "Show Path List"
         Height          =   375
         Left            =   2520
         TabIndex        =   3
         Top             =   1200
         Width           =   1815
      End
      Begin VB.CommandButton cmdAppPathCopyToListClipboard 
         Caption         =   "Copy List To Clipboard"
         Height          =   375
         Left            =   2520
         TabIndex        =   4
         Top             =   1680
         Width           =   1815
      End
   End
   Begin VB.Frame fraAmptekCommonFilesDirectory 
      Caption         =   "Amptek Common Files Directory"
      Height          =   2175
      Left            =   120
      TabIndex        =   13
      Top             =   4680
      Width           =   4455
      Begin VB.CommandButton cmdAmptekDirCopyListToClipboard 
         Caption         =   "Copy List To Clipboard"
         Height          =   375
         Left            =   2520
         TabIndex        =   12
         Top             =   1680
         Width           =   1815
      End
      Begin VB.CommandButton cmdAmptekDirRefreshList 
         Caption         =   "Refresh List"
         Height          =   375
         Left            =   2520
         TabIndex        =   11
         Top             =   1200
         Width           =   1815
      End
      Begin VB.CommandButton cmdAmptekDirRemoveFiles 
         Caption         =   "Remove Files"
         Height          =   375
         Left            =   2520
         TabIndex        =   10
         Top             =   720
         Width           =   1815
      End
      Begin VB.CommandButton cmdAmptekDirAddFiles 
         Caption         =   "Add Files"
         Height          =   375
         Left            =   2520
         TabIndex        =   9
         Top             =   240
         Width           =   1815
      End
      Begin VB.FileListBox filAmptekCommonFiles 
         Height          =   1845
         Left            =   120
         MultiSelect     =   2  'Extended
         TabIndex        =   8
         Top             =   240
         Width           =   2295
      End
   End
   Begin VB.Menu mnuKeyItemAction 
      Caption         =   "Key Item Action"
      Visible         =   0   'False
      Begin VB.Menu mnuKeyItemActionRun 
         Caption         =   "Run File"
      End
      Begin VB.Menu mnuKeyItemActionSysInfo 
         Caption         =   "Properties"
      End
      Begin VB.Menu mnuKeyItemActionFindFile 
         Caption         =   "Find File"
      End
   End
   Begin VB.Menu mnuAmptekItemAction 
      Caption         =   "Amptek Item Action"
      Visible         =   0   'False
      Begin VB.Menu mnuAmptekItemActionSysInfo 
         Caption         =   "Properties"
      End
      Begin VB.Menu mnuAmptekItemActionFindFile 
         Caption         =   "Find File"
      End
   End
End
Attribute VB_Name = "frmPathTool"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit



'Amptek dir - "C:\Program Files\Common Files\Amptek"
'locate DLL directory, select files (use search form), copy dll files to directory
Private Sub cmdAmptekDirAddFiles_Click()
    EnableControls False
    CopyFilesToCommonFilesDirectory strAmptekCommonFilePath
    ShowCommonFiles
    filAmptekCommonFiles.Refresh
    EnableControls True
End Sub

Private Sub cmdAmptekDirCopyListToClipboard_Click()
    Dim i As Integer
    Dim strText As String
    EnableControls False
    strText = ""
    If (filAmptekCommonFiles.Visible) Then
        For i = 0 To (filAmptekCommonFiles.ListCount - 1)
            strText = strText & filAmptekCommonFiles.path & "\" & filAmptekCommonFiles.List(i) & vbNewLine
        Next
        Clipboard.Clear                 ' Clear Clipboard.
        Clipboard.SetText strText       ' Put text on Clipboard.
    End If
    EnableControls True
End Sub

Private Sub cmdAmptekDirRefreshList_Click()
    EnableControls False
    ShowCommonFiles
    filAmptekCommonFiles.Refresh
    EnableControls True
End Sub

Private Sub cmdAmptekDirRemoveFiles_Click()
    Dim i As Integer
    EnableControls False
    If (filAmptekCommonFiles.Visible) Then
        For i = 0 To (filAmptekCommonFiles.ListCount - 1)
            If (filAmptekCommonFiles.Selected(i)) Then
                DeleteToRecycleBin filAmptekCommonFiles.path & "\" & filAmptekCommonFiles.List(i)
            End If
        Next
    End If
    cmdAmptekDirRefreshList_Click
    EnableControls True
End Sub

Private Sub cmdAppPathAddFiles_Click()
    'select files, update file list, add/update files in registry, log files to keys list
    EnableControls False
    CreateAppPaths lstAppPathKeys, lstAppPaths
    EnableControls True
End Sub

Private Sub cmdAppPathCopyToListClipboard_Click()
    Dim i As Integer
    Dim strText As String
    
    EnableControls False
    strText = ""
    For i = 0 To (lstAppPathKeys.ListCount - 1)
        strText = strText & lstAppPathKeys.List(i) & "=" & lstAppPaths.List(i) & vbNewLine
    Next
    If (strText <> "") Then
        Clipboard.Clear                 ' Clear Clipboard.
        Clipboard.SetText strText       ' Put text on Clipboard.
    End If
    EnableControls True
End Sub

Private Sub ShowCommonFiles()
    If (Dir(strAmptekCommonFilePath, vbDirectory) <> "") Then
        filAmptekCommonFiles.path = strAmptekCommonFilePath
        filAmptekCommonFiles.Visible = True
    Else
        filAmptekCommonFiles.path = App.path
        filAmptekCommonFiles.Visible = False
    End If
End Sub

Private Sub cmdAppPathRefreshList_Click()
    Dim i As Integer
    Dim strText As String
    
    EnableControls False
    strText = ""
    For i = 0 To (lstAppPathKeys.ListCount - 1)
        strText = strText & lstAppPathKeys.List(i) & "=" & lstAppPaths.List(i) & vbNewLine
    Next
    If (strText <> "") Then
        MsgBox strText
    Else
        MsgBox "No App Paths Listed."
    End If
    EnableControls True
End Sub

Private Sub cmdAppPathRemoveFiles_Click()
    EnableControls False
    UninstallAppPaths lstAppPathKeys, lstAppPaths
    EnableControls True
End Sub

Private Sub cmdAppPathSortList_Click()
    On Error GoTo cmdAppPathSortList_Err
    Dim strIniBackup As String
    Dim isBackupOK As Boolean
    Dim i As Integer
    Dim iSorted As Integer
    EnableControls False

    If (lstAppPathKeys.ListCount > 0) Then
        'backup old ini file
        FileCopy strAppPathsLog, strAppPathsLog & ".bak"    'don't want to loose the reg key values
        'create ini backup for acrchive
        strIniBackup = Left(strAppPathsLog, InStr(1, strAppPathsLog, ".") - 1) & _
                                "_" & Format(Now, "YYYYMMDD_HHNNSS") & ".ini"
        FileCopy strAppPathsLog, strIniBackup
        'first check if 1st backup exists and is identical
        isBackupOK = isIdenticalFile(strAppPathsLog, strAppPathsLog & ".bak")
        If (isBackupOK) Then    'check if timestamped backup exists and is identical
            isBackupOK = isIdenticalFile(strAppPathsLog, strIniBackup)
            If Not (isBackupOK) Then
                EnableControls True
                Exit Sub
            End If
        Else
            EnableControls True
            Exit Sub
        End If
        lstSort.Clear
        'copy all keys to sorted listbox to sort keys
        For i = 0 To lstAppPathKeys.ListCount - 1
            lstSort.AddItem lstAppPathKeys.List(i)
            lstSort.ItemData(lstSort.NewIndex) = i
        Next
        'remove all the keys from the ini file
        DeleteIniSettingEx strAppPathsLog, APP_PATH_SECTION
        'copy all the keys to the ini file in sorted order
        For i = 0 To lstSort.ListCount - 1
            iSorted = lstSort.ItemData(i)
            SaveToIniEx strAppPathsLog, APP_PATH_SECTION, lstAppPathKeys.List(iSorted), lstAppPaths.List(iSorted)
        Next
        'clear old keys
        lstAppPathKeys.Clear
        lstAppPaths.Clear
        'reload keys
        InitAppPathsLog lstAppPathKeys, lstAppPaths
    End If
    EnableControls True
    Exit Sub
cmdAppPathSortList_Err:
    MsgBox "There has been an error sorting the Key Paths. " & vbNewLine & _
            "====== PathTools Must Close. ======" & vbNewLine & _
            vbNewLine & _
            vbNewLine & _
            "====== !!!! RECOMMENDED ACTION !!!! ======" & vbNewLine & _
            "Check for the latest ini file and rename to: " & vbNewLine & _
            strAppPathsLog & vbNewLine & _
            "====== !!!! RECOMMENDED ACTION !!!! ======" & vbNewLine, vbCritical
    End
End Sub

Private Sub filAmptekCommonFiles_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If (Button And vbRightButton) Then PopupMenu mnuAmptekItemAction
End Sub

Private Sub mnuAmptekItemActionFindFile_Click()
    Dim RetVal As Variant
    Dim strPath As String
    If filAmptekCommonFiles.ListIndex = -1 Then Exit Sub
    strPath = filAmptekCommonFiles.path & "\" & filAmptekCommonFiles.List(filAmptekCommonFiles.ListIndex)
    'C:\WINDOWS\Explorer.exe /e,/select,"%1"
    RetVal = ShellExecute(Me.hWnd, 0, "Explorer.exe", "/e,/select," & """" & strPath & """", "", SW_SHOWNORMAL)
End Sub

Private Sub mnuAmptekItemActionSysInfo_Click()
    Dim strPath As String
    If filAmptekCommonFiles.ListIndex = -1 Then Exit Sub
    DisplaySystemInfoDialog strPath, Me.hWnd
End Sub

Private Sub Form_Load()
    Dim strSaveTitle As String
    
    If App.PrevInstance Then        'prevent duplicate instance
       AppActivate App.Title
       SendKeys "% R", True
       End
    End If

    InitAppPathsLog lstAppPathKeys, lstAppPaths
    ShowCommonFiles     'display common files if directory exists
End Sub

Private Sub lstAppPathKeys_Click()
    txtAppPath = lstAppPaths.List(lstAppPathKeys.ListIndex)
End Sub

Private Sub lstAppPathKeys_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If (Button And vbRightButton) Then PopupMenu mnuKeyItemAction
End Sub

Private Sub mnuKeyItemActionFindFile_Click()
    Dim RetVal As Variant
    Dim strPath As String
    If lstAppPathKeys.ListIndex = -1 Then Exit Sub
    strPath = lstAppPaths.List(lstAppPathKeys.ListIndex)
    'C:\WINDOWS\Explorer.exe /e,/select,"%1"
    RetVal = ShellExecute(Me.hWnd, 0, "Explorer.exe", "/e,/select," & """" & strPath & """", "", SW_SHOWNORMAL)
End Sub

Private Sub mnuKeyItemActionRun_Click()
    Dim strPath As String
    Dim RetVal As Variant
    If lstAppPathKeys.ListIndex = -1 Then Exit Sub
    strPath = lstAppPaths.List(lstAppPathKeys.ListIndex)
    RetVal = ShellExecute(Me.hWnd, 0, strPath, "", "", SW_SHOWNORMAL)
End Sub

Private Sub mnuKeyItemActionSysInfo_Click()
    Dim strPath As String
    If lstAppPathKeys.ListIndex = -1 Then Exit Sub
    strPath = lstAppPaths.List(lstAppPathKeys.ListIndex)
    DisplaySystemInfoDialog strPath, Me.hWnd
End Sub

Private Sub EnableControls(isEnabled As Boolean)
    cmdAmptekDirAddFiles.Enabled = isEnabled
    cmdAmptekDirCopyListToClipboard.Enabled = isEnabled
    cmdAmptekDirRefreshList.Enabled = isEnabled
    cmdAmptekDirRemoveFiles.Enabled = isEnabled
    cmdAppPathAddFiles.Enabled = isEnabled
    cmdAppPathCopyToListClipboard.Enabled = isEnabled
    cmdAppPathRefreshList.Enabled = isEnabled
    cmdAppPathRemoveFiles.Enabled = isEnabled
    cmdAppPathSortList.Enabled = isEnabled
End Sub


















