VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "comctl32.ocx"
Begin VB.Form frmDPPMCA 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Spectrum Configuration Extraction Utility"
   ClientHeight    =   7590
   ClientLeft      =   150
   ClientTop       =   570
   ClientWidth     =   7095
   Icon            =   "Plot2Cfg.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   ScaleHeight     =   7590
   ScaleWidth      =   7095
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame fraDPPDeviceType 
      Caption         =   "DPP Device Type"
      Height          =   495
      Left            =   120
      TabIndex        =   29
      Top             =   120
      Width           =   4575
      Begin VB.OptionButton OptDPPType 
         Caption         =   "DP4"
         Height          =   195
         Index           =   0
         Left            =   120
         TabIndex        =   33
         Top             =   240
         Width           =   615
      End
      Begin VB.OptionButton OptDPPType 
         Caption         =   "PX4"
         Height          =   195
         Index           =   1
         Left            =   840
         TabIndex        =   32
         Top             =   240
         Width           =   615
      End
      Begin VB.OptionButton OptDPPType 
         Caption         =   "DP4 Emulation"
         Height          =   195
         Index           =   2
         Left            =   1560
         TabIndex        =   31
         Top             =   240
         Width           =   1455
      End
      Begin VB.OptionButton OptDPPType 
         Caption         =   "PX4 Emulation"
         Height          =   195
         Index           =   3
         Left            =   3000
         TabIndex        =   30
         Top             =   240
         Value           =   -1  'True
         Width           =   1455
      End
   End
   Begin VB.Frame fraFPGAClock 
      Caption         =   "FPGA Clock"
      Height          =   495
      Left            =   4920
      TabIndex        =   26
      Top             =   120
      Visible         =   0   'False
      Width           =   2055
      Begin VB.OptionButton optFPGAClock 
         Caption         =   "20MHz"
         Height          =   195
         Index           =   0
         Left            =   120
         TabIndex        =   28
         Top             =   240
         Value           =   -1  'True
         Width           =   855
      End
      Begin VB.OptionButton optFPGAClock 
         Caption         =   "80MHz"
         Height          =   195
         Index           =   1
         Left            =   1080
         TabIndex        =   27
         Top             =   240
         Width           =   855
      End
   End
   Begin VB.Frame fraXLConfig 
      Caption         =   "Create configurations from Excel Spreadsheet or Amptek DPP MCA Spectrum file"
      Height          =   3735
      Left            =   120
      TabIndex        =   12
      Top             =   720
      Width           =   6855
      Begin VB.TextBox txtCfgDescription 
         Height          =   285
         Left            =   1800
         TabIndex        =   20
         Text            =   "live_data"
         Top             =   1560
         Width           =   3015
      End
      Begin VB.TextBox txtCfgFilename 
         Height          =   285
         Left            =   2400
         TabIndex        =   19
         Text            =   "live_data"
         Top             =   1200
         Width           =   2415
      End
      Begin VB.CommandButton cmdCreateCfgFromXL 
         Caption         =   "Create Configurations From Excel or MCA"
         Height          =   255
         Left            =   1560
         TabIndex        =   4
         Top             =   3000
         Width           =   3255
      End
      Begin VB.CommandButton cmdSelectExcelFile 
         Caption         =   "Select Excel or DPP MCA Plot File"
         Height          =   255
         Left            =   1680
         TabIndex        =   0
         Top             =   360
         Width           =   3135
      End
      Begin VB.TextBox txtXLStartCol 
         Height          =   285
         Left            =   2520
         TabIndex        =   2
         Text            =   "2"
         Top             =   2280
         Width           =   495
      End
      Begin VB.TextBox txtXLEndCol 
         Height          =   285
         Left            =   3720
         TabIndex        =   3
         Text            =   "2"
         Top             =   2280
         Width           =   495
      End
      Begin VB.TextBox txtXlFilename 
         Height          =   285
         Left            =   120
         TabIndex        =   1
         Text            =   "live_data.mca"
         Top             =   600
         Width           =   6615
      End
      Begin VB.Label Label1 
         Alignment       =   2  'Center
         Caption         =   "========                 ========"
         Height          =   255
         Left            =   120
         TabIndex        =   25
         Top             =   2640
         Width           =   4695
      End
      Begin VB.Label lblForXlsOnly 
         Alignment       =   2  'Center
         BackStyle       =   0  'Transparent
         Caption         =   "======== Step 2  For Excel Xls Only ========"
         Height          =   255
         Left            =   120
         TabIndex        =   24
         Top             =   1920
         Width           =   4695
      End
      Begin VB.Label lblForMcaPlot 
         Alignment       =   2  'Center
         Caption         =   "======== Step 2  For Mca Plot Only ========"
         Height          =   255
         Left            =   120
         TabIndex        =   23
         Top             =   960
         Width           =   4695
      End
      Begin VB.Label lblCfgDescription 
         Caption         =   "2b. Cfg Description"
         Height          =   255
         Left            =   120
         TabIndex        =   22
         Top             =   1560
         Width           =   1575
      End
      Begin VB.Label lblCfgFilename 
         Caption         =   "2a. Cfg Filename (w/o ext)"
         Height          =   255
         Left            =   120
         TabIndex        =   21
         Top             =   1200
         Width           =   2175
      End
      Begin VB.Label lblNewCfgFileLoc 
         Caption         =   "4. New Configuration files are located in AppPath\DET_CFG."
         Height          =   255
         Left            =   120
         TabIndex        =   18
         Top             =   3360
         Width           =   4455
      End
      Begin VB.Label lblRunConversion 
         Caption         =   "3. Run Conversion"
         Height          =   255
         Left            =   120
         TabIndex        =   17
         Top             =   3000
         Width           =   1335
      End
      Begin VB.Label lblXLEnd 
         Alignment       =   1  'Right Justify
         Caption         =   "End"
         Height          =   255
         Left            =   3240
         TabIndex        =   16
         Top             =   2280
         Width           =   375
      End
      Begin VB.Label lblXLStart 
         Alignment       =   1  'Right Justify
         Caption         =   "Start"
         Height          =   255
         Left            =   1800
         TabIndex        =   15
         Top             =   2280
         Width           =   615
      End
      Begin VB.Label lblSelectColumns 
         Caption         =   "2. Select Columns"
         Height          =   255
         Left            =   120
         TabIndex        =   14
         Top             =   2280
         Width           =   1335
      End
      Begin VB.Label lblXlFilename 
         Caption         =   "1. Select File"
         Height          =   255
         Left            =   120
         TabIndex        =   13
         Top             =   360
         Width           =   1095
      End
   End
   Begin VB.Frame fraTestXLConfig 
      Caption         =   "Test configurations from Excel Spreadsheet or Amptek DPP MCA Spectrum file"
      Height          =   2655
      Left            =   120
      TabIndex        =   8
      Top             =   4560
      Width           =   6855
      Begin VB.TextBox txtXLTestResults 
         Height          =   1455
         Left            =   120
         MultiLine       =   -1  'True
         ScrollBars      =   2  'Vertical
         TabIndex        =   6
         Top             =   1080
         Width           =   4695
      End
      Begin VB.CommandButton cmdRunPlot2CfgTest 
         Caption         =   "Test Configurations From Excel or MCA DPP Plot"
         Height          =   255
         Left            =   1080
         TabIndex        =   5
         Top             =   720
         Width           =   3735
      End
      Begin VB.Label lblRunPlot2CfgTest 
         Caption         =   "3. Run Test"
         Height          =   255
         Left            =   120
         TabIndex        =   11
         Top             =   720
         Width           =   855
      End
      Begin VB.Label lblSelectTestCols 
         Caption         =   "2. Select Filename and Start/End Test Columns (ABOVE)"
         Height          =   255
         Left            =   120
         TabIndex        =   10
         Top             =   480
         Width           =   4575
      End
      Begin VB.Label lblCreateCfgFromExcelBeforeTest 
         Caption         =   "1. Create Configurations (ABOVE)  Before Testing"
         Height          =   255
         Left            =   120
         TabIndex        =   9
         Top             =   240
         Width           =   4455
      End
   End
   Begin ComctlLib.StatusBar StatusBar1 
      Align           =   2  'Align Bottom
      Height          =   375
      Left            =   0
      TabIndex        =   7
      Top             =   7215
      Width           =   7095
      _ExtentX        =   12515
      _ExtentY        =   661
      SimpleText      =   ""
      _Version        =   327682
      BeginProperty Panels {0713E89E-850A-101B-AFC0-4210102A8DA7} 
         NumPanels       =   1
         BeginProperty Panel1 {0713E89F-850A-101B-AFC0-4210102A8DA7} 
            AutoSize        =   1
            Object.Width           =   12462
            TextSave        =   ""
            Key             =   ""
            Object.Tag             =   ""
         EndProperty
      EndProperty
   End
   Begin MSComDlg.CommonDialog cmnDlg 
      Left            =   0
      Top             =   2040
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
End
Attribute VB_Name = "frmDPPMCA"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public pnlStatus As Panel       ' status display panel

'reads the selected MCA File Settings and creates corresponding configuration files
Private Sub RunCreateCfgFromMCA()
    Dim i As Long
    Dim colPlot2Cfg As New Collection
    Dim bufferCFG As Variant
    Dim iSizeCFG As ArrayIndex                 '
    
    EnableControls False
    bufferCFG = LoadSpectrumCFG(txtXlFilename, txtCfgFilename, txtCfgDescription)
    iSizeCFG = GetArrayIndex(bufferCFG)
    DppDevice = GetDPPTypeFromString(CStr(bufferCFG(iSizeCFG.idxU)))
    For i = iSizeCFG.idxL To iSizeCFG.idxU
        colPlot2Cfg.Add bufferCFG(i)
    Next
    CreateCfgDir
    CreateCfgFromXLSettings colPlot2Cfg
    pnlStatus = "MCA Dpp configurations done."
    Refresh
    EnableControls True
End Sub

Private Sub cmdCreateCfgFromXL_Click()
    Dim strExt As String
    strExt = GetFileExtension(txtXlFilename)
    strExt = LCase(strExt)
    If (strExt = "mca") Then
        RunCreateCfgFromMCA
    ElseIf (strExt = "xls") Then
        RunCreateCfgFromXL
    End If
End Sub

Private Sub cmdRunPlot2CfgTest_Click()
    Dim strExt As String
    strExt = GetFileExtension(txtXlFilename)
    strExt = LCase(strExt)
    If (strExt = "mca") Then
        RunPlot2CfgTestMCA
    ElseIf (strExt = "xls") Then
        RunXLCfgTest
    End If
End Sub

'initializes controls before form load
Private Sub Form_Initialize()
    InitCommonControls          'load the common control DLL
End Sub

'enable/disable form controls
Private Sub EnableControls(isEnabled As Boolean)
    cmdSelectExcelFile.Enabled = isEnabled
    txtXlFilename.Enabled = isEnabled
    txtXLStartCol.Enabled = isEnabled
    txtXLEndCol.Enabled = isEnabled
    cmdCreateCfgFromXL.Enabled = isEnabled
    cmdRunPlot2CfgTest.Enabled = isEnabled
    txtXLTestResults.Enabled = isEnabled
End Sub

'updates the config dialog for the correct device settings
'used before creating configuration files with the frmCfgDlg
Private Sub ConfigLoadFromFile(NewDeviceType As Integer, strFilename As String)
    Dim lenFilename As Long
    If (objDppApi = 0) Then Exit Sub            'exit sub if api is not present
    If ((NewDeviceType > DPPNONE) And (NewDeviceType <= DPPDP5)) Then   'check if the device type is in range
        DppDevice = NewDeviceType                               'set the new device type
        lenFilename = Len(strFilename)                          'holds the dummy configuration file to be loaded
        If (DppDevice > DPPPX4) Then                            'turn on the FPGA Clock options for DP5 devices
            fraFPGAClock.Visible = True
            If ((DppDevice = DPPDP4EMUL) Or (DppDevice = DPPDP5)) Then
                Dpp80MHzMode = GetOption(optFPGAClock)
                SetFPGAClockDefault objDppApi, Dpp80MHzMode, DppDevice  'Set the FPGA Clock setting
            End If
        Else
            SetFPGAClockDefault objDppApi, 0, DppDevice         'no FPGA clock settings for DP4, PX4
            fraFPGAClock.Visible = False
        End If
        OptDPPType(DppDevice - 1).value = True                  'set the new device type option
        GetConfigFromFile objDppApi, strFilename, lenFilename, DppDevice
        pnlStatus = "Configuration loaded from file."
    End If
End Sub

Public Function GetOption(opts As Object) As Integer
    On Error GoTo GetOptionErr
    Dim opt As OptionButton
    For Each opt In opts
        If opt.value Then
            GetOption = opt.Index
            Exit Function
        End If
    Next
GetOptionErr:
    GetOption = -1
End Function

'option buttons select the current device type
Private Sub OptDPPType_Click(Index As Integer)
    Dim strDppType As String
    SaveSetting App.ExeName, "Settings", "DPPDeviceType", (Index + 1)
    strDppType = DPPTypeString(Index + 1) & " Device Type Selected"
    If ((GetOption(OptDPPType) + 1) > DPPPX4) Then
        fraFPGAClock.Visible = True
    Else
        fraFPGAClock.Visible = False
    End If
End Sub

'option buttons select the fpga clock for file cfg
Private Sub optFPGAClock_Click(Index As Integer)
    SaveSetting App.ExeName, "Settings", "Dpp80MHzMode", Index
End Sub

'initializes controls when the form is loaded
Private Sub Form_Load()
    Dim RunningXL As Boolean                    ' Excel is Enabled and Running
    
    txtCfgFilename.Text = GetSetting(App.ExeName, "Settings", "CfgFilename", "live_data")
    txtCfgDescription.Text = GetSetting(App.ExeName, "Settings", "CfgDescription", "live_data")
    
    RunningXL = GetExcelPath()
    HasPlotCursorSupport = False                'turns off cursor support in config dialog
    If Not RunningXL Then
        MsgBox "Excel cannot be found. " & vbNewLine & "Excel features are disabled."
        End
    End If
    Set pnlStatus = StatusBar1.Panels(1)        'set status display panel
    pnlStatus = "Creating DppApi Interface..."  'display status
    DppDevice = GetSetting(App.ExeName, "Settings", "DPPDeviceType", 1) 'set the global device type to the last dpp device type selected
    If (DppDevice > DPPPX4) Then
        fraFPGAClock.Visible = True
    Else
        fraFPGAClock.Visible = False
    End If
    Dpp80MHzMode = GetSetting(App.ExeName, "Settings", "Dpp80MHzMode", 0)
    If ((DppDevice > DPPDP5) Or (DppDevice < DPPDP4)) Then DppDevice = 2
    
    DppFirmwareRev = 4                          'set default firmware rev
    DppFPGARev = 4                              'set default fpga rev
    
    OptDPPType(DppDevice - 1).value = True          'set the device type
    optFPGAClock(Dpp80MHzMode).value = True
    
    objDppApi = 0                               'set the dppapi pointer to null
    ChDir App.path                              'set the default dir to the app path
    objDppApi = OpenDppApi()                    'create DppApi Object
    If (objDppApi > 0) Then                     'enable the load cfg controls if ready
        ConfigLoadFromFile DppDevice, App.path & "\dpp.cfg"
        If (objDppApi > 0) Then
            XLCfgUpdatesDone = False
            Load frmCfgDlg
            Set frmCfgDlg.DataAcqTimer = Nothing
            frmCfgDlg.Hide
            If (XLCfgUpdatesDone) Then
                pnlStatus = "Configuration edit done. Please save your changes."
            Else
                pnlStatus = "No configuration changes were made during edit session."
            End If
        End If
        If (RunningXL) Then
            txtXlFilename = App.path & "\xlAppCls.xls"
            txtXlFilename = GetSetting(App.ExeName, "Settings", "XLFilename", txtXlFilename)
        End If
    Else                            'else quit the application on dppapi error
        pnlStatus = "DppApi Interface error."
        MsgBox "DppApi Interface error." & vbNewLine & "The application must close.", vbCritical
        End
    End If
    Sleep (1000)
    pnlStatus = "Ready to create configurations from an Excel spreadsheet."
End Sub

'closes dppapi and open forms (configuration form is hidden when running)
Private Sub Form_Unload(Cancel As Integer)
    CloseDppApi (objDppApi)
    objDppApi = 0
    
    SaveSetting App.ExeName, "Settings", "CfgFilename", txtCfgFilename.Text
    SaveSetting App.ExeName, "Settings", "CfgDescription", txtCfgDescription.Text

    pnlStatus = "Plot2Cfg Closing"
    Shutdown
    End
End Sub

'unloads all open forms
'   forms not unloaded at shutdown can cause the application to remain running
'   this causes a "zombie process" and can only shut down by the Task Manager
Public Sub Shutdown(Optional ByVal Force As Boolean = False)
      Dim i As Long
      On Error Resume Next
      For i = Forms.Count - 1 To 0 Step -1
         Unload Forms(i) ' Triggers QueryUnload and Form_Unload
         ' If we aren't in Force mode and the unload failed, stop the shutdown.
         If Not CBool(Force) Then
            If Forms.Count > i Then
               Exit Sub
            End If
         End If
      Next i
      ' If we are in Force mode OR all forms unloaded, close all files.
      If Force Or (Forms.Count = 0) Then Close
      ' If we are in Force mode AND all forms not unloaded, end.
      If Force Or (Forms.Count > 0) Then End
End Sub

'get record (goto end of line),get field name,get field value,assign to var
Private Function GetNextRecord(ByRef strList As String) As Variant
    On Error Resume Next
    Dim strListTemp As String
    Dim strRecord As String
    Dim strVal As String
    Dim RecEnd As Long
    Dim ValPos As Long
    Dim varVal As Variant
    strListTemp = strList   'make copy of list
    RecEnd = InStr(1, strList, vbNewLine, vbTextCompare)
    If (RecEnd > 0) Then
        strRecord = Trim(Left(strList, RecEnd - 1))
        strListTemp = Trim(Mid(strList, RecEnd + 2))
    Else
        strRecord = Trim(strList)
        strListTemp = ""
    End If
    ValPos = InStr(1, strRecord, "=", vbTextCompare)
    If (ValPos > 0) Then
        varVal = Trim(Mid(strRecord, ValPos + 1))
    Else
        varVal = ""
    End If
    strList = strListTemp
    GetNextRecord = varVal
End Function

'==============================================
'===Start of Excel Code========================
'==============================================

'converts configuration strings with text representing OFF and ON to a long
Public Function GetOffOnIndexFromString(strOffOn As String) As Long
    If (InStr(1, strOffOn, "off", vbTextCompare)) Then
        GetOffOnIndexFromString = 0
    Else
        GetOffOnIndexFromString = 1
    End If
End Function

'calculates log of X to the base N and returns the results as a long
Public Function LogNLng(LogOfX As Long, ToTheBaseN As Long) As Long
    LogNLng = Log(LogOfX) / Log(ToTheBaseN)
End Function

'converts BLR string value to a numeric value
Public Function GetBLRFromString(strBLRIn As String, Optional Dpp80MHzMode As Integer = 0) As Long
    Dim strBLR As String
    Dim BLR0 As Long
    Dim BLR1 As Long
    Dim sepPos As Long
    
    If (InStr(1, strBLRIn, "off", vbTextCompare)) Then
        GetBLRFromString = 0
    ElseIf (InStr(1, strBLRIn, "slow", vbTextCompare)) Then
        GetBLRFromString = BLRToSpin(CByte(&H64))
    ElseIf (InStr(1, strBLRIn, "medium", vbTextCompare)) Then
        GetBLRFromString = BLRToSpin(CByte(&H68))
    ElseIf (InStr(1, strBLRIn, "fast", vbTextCompare)) Then
        GetBLRFromString = BLRToSpin(CByte(&H7C))
    Else
        strBLR = Trim(strBLRIn)
        sepPos = InStr(1, strBLR, " ")
        If (sepPos > 0) Then
            BLR0 = Val(Mid(strBLR, sepPos + 1))
            If (Dpp80MHzMode <> 0) Then BLR0 = BLR0 / 4     '80MHzMode 4x faster
            BLR1 = Val(Left(strBLR, sepPos - 1))
            If (Dpp80MHzMode <> 0) Then BLR1 = BLR1 / 4     '80MHzMode 4x faster
            GetBLRFromString = (LogNLng(BLR1, 4) * 4) + LogNLng(BLR0, 4) + 1
        Else
            GetBLRFromString = 0
        End If
    End If
End Function

'creates a configuration file from a collection of Excel Setting Values
Private Sub CreateCfgFromXLSettings(colCfg As Collection, Optional isXL As Boolean = False)
    Dim cboIdx As Long
    Dim strSetting As String
    Dim strFilename As String
    Dim strDescription As String
    Dim cfgIndex As Integer
    Dim lenFilename As Long
    Dim strDefaultCfg As String
    Dim CurDppDevice As Integer
    Dim strDPPDevice As String

    If (colCfg.Count <> 31) Then
        MsgBox "XL Configuration Error, number settings incorrect.", vbCritical
        Exit Sub
    End If
    strDefaultCfg = App.path & "\DPP.cfg"
    strDPPDevice = UCase(Trim(colCfg(31)))
    CurDppDevice = GetDPPTypeFromString(strDPPDevice)
    If (CurDppDevice = 0) Then Exit Sub
    ConfigLoadFromFile CurDppDevice, App.path & "\dpp.cfg"
    frmCfgDlg.LoadTempConfig
    'frmCfgDlg.Show
    Refresh
    DoEvents

    cfgIndex = 1  'starting configuration collection  index
    
    '--- Configuration Filename --------------------------------------------
    If (Len(Trim(colCfg(cfgIndex))) = 0) Then Exit Sub
    strFilename = "DET_CFG\" & Trim(colCfg(cfgIndex)) & ".cfg"
    cfgIndex = cfgIndex + 1
    
    '--- Configuration Description -----------------------------------------
    strDescription = colCfg(cfgIndex)
    cfgIndex = cfgIndex + 1
    
    '--- Port Setting ------------------------------------------------------
    'the port setting is always USB
    cfgIndex = cfgIndex + 1
    
    '--- Rise --------------------------------------------------------------
    cboIdx = GetListObjIndex(frmCfgDlg.cboTimeToPeak, colCfg(cfgIndex))
    If (cboIdx >= 0) Then frmCfgDlg.cboTimeToPeak.ListIndex = cboIdx
    cfgIndex = cfgIndex + 1
    
    '--- Top ---------------------------------------------------------------
    cboIdx = GetListObjIndex(frmCfgDlg.cboFlatTop, colCfg(cfgIndex), False)
    If (cboIdx >= 0) Then frmCfgDlg.cboFlatTop.ListIndex = cboIdx
    cfgIndex = cfgIndex + 1
    
    '---  FastChThreshold --------------------------------------------------
    Dim fastthresh As Integer
    frmCfgDlg.txtFastThreshold = colCfg(cfgIndex)
    fastthresh = Val(frmCfgDlg.txtFastThreshold)
    If ((fastthresh >= 0) And (fastthresh <= 250)) Then
        frmCfgDlg.udFastThreshold.value = fastthresh
    End If
    frmCfgDlg.udFastThresholdChange
    cfgIndex = cfgIndex + 1
    
    '--- PUR Enable --------------------------------------------------------
    frmCfgDlg.cboPUR.ListIndex = GetOffOnIndexFromString(colCfg(cfgIndex))
    cfgIndex = cfgIndex + 1
    
    '--- RTD ON/OFF --------------------------------------------------------
    frmCfgDlg.cboRTD.ListIndex = GetOffOnIndexFromString(colCfg(cfgIndex))
    cfgIndex = cfgIndex + 1
    
    Refresh
    DoEvents
    
    If (DppDevice = DPPDP5) Then
        '--- RTD Ratio ---------------------------------------------------------
        Dim dblRTDSlowDP5 As Double
        Dim strRTDSlowDP5 As String
        strRTDSlowDP5 = GetXLPercentDoubleStr(colCfg(cfgIndex))
        dblRTDSlowDP5 = atof(strRTDSlowDP5)
        frmCfgDlg.udRTDSlow.value = CLng(CDbl((dblRTDSlowDP5 * 64#) / 100#))
        cfgIndex = cfgIndex + 1

        '--- RTD Slow Thres ----------------------------------------------------
        Dim dblRTDFast As Double
        Dim strRTDFast As String
        strRTDFast = GetXLPercentDoubleStr(colCfg(cfgIndex))
        dblRTDFast = atof(strRTDFast)
        frmCfgDlg.udRTDFast.value = CLng(((dblRTDFast / 16# * 512#) / 100#) + 4#)
        cfgIndex = cfgIndex + 1
    Else
        '--- RTD threshold -----------------------------------------------------
        Dim dblRTDSlow As Double
        Dim strRTDSlow As String
        strRTDSlow = GetXLPercentDoubleStr(colCfg(cfgIndex))
        dblRTDSlow = atof(strRTDSlow)
        frmCfgDlg.udRTDSlow.value = CLng(CDbl((dblRTDSlow / 100# * 512#)))
        cfgIndex = cfgIndex + 1
        
        '--- RTD Fast HWHM -----------------------------------------------------
        frmCfgDlg.udRTDFast.value = CLng(atof(colCfg(cfgIndex)))
        cfgIndex = cfgIndex + 1
    End If
    
    '--- AutoBaseline ------------------------------------------------------
    frmCfgDlg.cboAutoBaseline.ListIndex = GetOffOnIndexFromString(colCfg(cfgIndex))
    cfgIndex = cfgIndex + 1
    
    '--- BLR ---------------------------------------------------------------
    frmCfgDlg.cboBLR.ListIndex = GetBLRFromString(colCfg(cfgIndex), Dpp80MHzMode)
    cfgIndex = cfgIndex + 1
    
    '--- Acquisition Mode --------------------------------------------------
    'cfgIndex = cfgIndex + 1
    '--- MCS Timebase ------------------------------------------------------
    'cfgIndex = cfgIndex + 1
    
    '--- MCA Channels ------------------------------------------------------
    cboIdx = GetListObjIndex(frmCfgDlg.cboMCAChannels, colCfg(cfgIndex))
    If (cboIdx >= 0) Then frmCfgDlg.cboMCAChannels.ListIndex = cboIdx
    cfgIndex = cfgIndex + 1
    '--- SlowChThreshold ---------------------------------------------------
    Dim dblSlowThreshold As Double
    Dim strXLPercent As String
    strXLPercent = GetXLPercentDoubleStr(colCfg(cfgIndex))
    dblSlowThreshold = atof(strXLPercent)
    frmCfgDlg.txtSlowThresholdPercent = dblSlowThreshold
    frmCfgDlg.txtSlowThresholdPercent_Click
    cfgIndex = cfgIndex + 1
    '--- Buffer Select -----------------------------------------------------
    cboIdx = GetListObjIndex(frmCfgDlg.cboBufferSelect, colCfg(cfgIndex))
    If (cboIdx >= 0) Then frmCfgDlg.cboBufferSelect.ListIndex = cboIdx
    cfgIndex = cfgIndex + 1
    '--- Gate Input (TTL) --------------------------------------------------
    cboIdx = GetListObjIndex(frmCfgDlg.cboGate, colCfg(cfgIndex))
    If (cboIdx >= 0) Then frmCfgDlg.cboGate.ListIndex = cboIdx
    cfgIndex = cfgIndex + 1
    
    Refresh
    DoEvents
    
    '--- Preset Time -------------------------------------------------------
    cboIdx = GetListObjIndex(frmCfgDlg.cboPresetTime, colCfg(cfgIndex))
    If (cboIdx >= 0) Then
        frmCfgDlg.cboPresetTime.ListIndex = cboIdx
    Else
        'get preset number
        'if isNumeric and > 0 then enter text, click
    End If
    cfgIndex = cfgIndex + 1
    
    '--- Coarse Gain & Fine Gain -------------------------------------------
    Dim dblCoarseGain As Double
    Dim dblFineGain As Double
    Dim dblGain As Double
  
    dblCoarseGain = atof(colCfg(cfgIndex))
    frmCfgDlg.txtCoarseGain = dblCoarseGain
    frmCfgDlg.txtCoarseGain_Click
    cfgIndex = cfgIndex + 1
    dblFineGain = atof(colCfg(cfgIndex))
    frmCfgDlg.txtFineGain = dblFineGain
    frmCfgDlg.txtFineGain_Click
    
    cfgIndex = cfgIndex + 1
    
    '--- Input Polarity ----------------------------------------------------
    cboIdx = GetListObjIndex(frmCfgDlg.cboInputPolarity, colCfg(cfgIndex))
    If (cboIdx >= 0) Then frmCfgDlg.cboInputPolarity.ListIndex = cboIdx
    cfgIndex = cfgIndex + 1
    '--- InputOffset -------------------------------------------------------
    frmCfgDlg.txtInputOffset = colCfg(cfgIndex)
    frmCfgDlg.txtInputOffset_Click
    cfgIndex = cfgIndex + 1
    '--- PoleZero ----------------------------------------------------------
    frmCfgDlg.txtPZ = colCfg(cfgIndex)
    frmCfgDlg.txtPZ_KeyUp 0, 0
    cfgIndex = cfgIndex + 1
    '--- Det Rst Lockout ---------------------------------------------------
    cboIdx = GetListObjIndexEx(frmCfgDlg.cboReset, colCfg(cfgIndex), False)
    If (cboIdx >= 0) Then frmCfgDlg.cboReset.ListIndex = cboIdx
    cfgIndex = cfgIndex + 1
    '--- TEC ---------------------------------------------------------------
    frmCfgDlg.txtTEC = colCfg(cfgIndex)
    frmCfgDlg.txtTEC_Click
    cfgIndex = cfgIndex + 1
    '--- HV ----------------------------------------------------------------
    frmCfgDlg.txtHV = colCfg(cfgIndex)
    frmCfgDlg.txtHV_Click
    cfgIndex = cfgIndex + 1
    
    Refresh
    DoEvents

    '--- Preamp Power ------------------------------------------------------
    cboIdx = GetListObjIndex(frmCfgDlg.cboPreampVoltage, colCfg(cfgIndex), False)
    If (cboIdx >= 0) Then frmCfgDlg.cboPreampVoltage.ListIndex = cboIdx
    cfgIndex = cfgIndex + 1
    '--- Analog Out --------------------------------------------------------
    cboIdx = GetListObjIndex(frmCfgDlg.cboDAC, colCfg(cfgIndex), False)
    If (cboIdx >= 0) Then frmCfgDlg.cboDAC.ListIndex = cboIdx
    cfgIndex = cfgIndex + 1
    '--- Output Offset -----------------------------------------------------
    frmCfgDlg.txtOutputOffset = colCfg(cfgIndex)
    frmCfgDlg.txtOutputOffset_Click
    cfgIndex = cfgIndex + 1
    '--- Aux ---------------------------------------------------------------
    cboIdx = GetListObjIndex(frmCfgDlg.cboAux, colCfg(cfgIndex), False)
    If (cboIdx >= 0) Then frmCfgDlg.cboAux.ListIndex = cboIdx
    cfgIndex = cfgIndex + 1
    '--- Audio -------------------------------------------------------------
    Dim intAudio As Integer
    cboIdx = GetListObjIndex(frmCfgDlg.cboAudibleCounterSettings, colCfg(cfgIndex), False)
    If (cboIdx >= 0) Then
        frmCfgDlg.cboAudibleCounterSettings.ListIndex = cboIdx
    Else
        intAudio = CInt(atof(colCfg(cfgIndex)))
        If ((intAudio >= 0) And (intAudio <= 3)) Then
            frmCfgDlg.cboAudibleCounterSettings.ListIndex = intAudio
        End If
    End If
    cfgIndex = cfgIndex + 1
 
    frmCfgDlg.ApplyCfgXL      'apply the settings
    SaveDetIniEntry strDescription, strFilename
    Sleep (100)
    strFilename = App.path & "\" & strFilename
    lenFilename = Len(strFilename)
    SaveConfigToFile objDppApi, strFilename, lenFilename
    Sleep (100)
    DoEvents
    If (DppDevice <> CurDppDevice) Then     'if the device type was swapped, restore it
        'if the device type is a dp4, a px4 default config must be restored
        If (DppDevice = 0) Then
            strDefaultCfg = App.path & "\DP4.cfg"
        Else
            strDefaultCfg = App.path & "\PX4.cfg"
        End If
        lenFilename = Len(strDefaultCfg)
        GetConfigFromFile objDppApi, strDefaultCfg, lenFilename, DppDevice
        Sleep (100)
        frmCfgDlg.LoadTempConfig
        Sleep (100)
    End If
    Refresh
End Sub

'saves a detector type entry to the Amptek Detector Configuration ini file
Private Sub SaveDetIniEntry(strKey As String, strData As String)
    Dim iniFile As String
    Dim Section As String
    iniFile = App.path & "\DET_CFG\AmptekDC.ini"
    Section = "Amptek Detector Configurations"
    SaveToIniEx iniFile, Section, strKey, strData
End Sub

'reads the selected Excel Settings and creates corresponding configuration files
Private Sub RunCreateCfgFromXL()
    Dim i As Long
    Dim j As Long
    Dim colPlot2Cfg As Collection
    Dim colPlot2CfgCol As New Collection
    Dim bRes As Boolean
    
    EnableControls False
    bRes = OpenWorkSheet(Trim(txtXlFilename))

    If (xlAppCls1 Is Nothing) Then Exit Sub
    'get the xl configuration settings for selected columns
    For j = Val(txtXLStartCol) To Val(txtXLEndCol)
        Refresh
        pnlStatus = "Reading configuration in column " & j & "."
        Refresh
        Set colPlot2Cfg = New Collection
        For i = 1 To 31
            colPlot2Cfg.Add xlAppCls1.GetCellValue(i, j)
        Next
        colPlot2CfgCol.Add colPlot2Cfg
    Next
    QuitWorkbook            'close xl
    CreateCfgDir
    Set colPlot2Cfg = Nothing
    For Each colPlot2Cfg In colPlot2CfgCol
        Refresh
        If (colPlot2Cfg.Count > 3) Then
            pnlStatus = "Processing configuration  " & colPlot2Cfg.Item(2) & "."
        End If
        Refresh
        CreateCfgFromXLSettings colPlot2Cfg, True
    Next
    pnlStatus = "Excel spreadsheet configurations done."
    Refresh
    EnableControls True
End Sub

'creates the default configuration storage directory
Private Sub CreateCfgDir()
    Dim strCfgDir As String
    On Error Resume Next
    strCfgDir = Trim(Dir(App.path & "\DET_CFG"))
    If (Len(strCfgDir) = 0) Then
        If (Not CBool(DirExists(App.path & "\DET_CFG"))) Then
            MkDir (App.path & "\DET_CFG")
        End If
    End If
End Sub

'selects the current Excel Spreadsheet file
Private Sub cmdSelectExcelFile_Click()
    EnableControls False
    If (dlgOpen(cmnDlg, dlgMCA_XLS_Filter)) Then
        txtXlFilename = cmnDlg.filename
        SaveSetting App.ExeName, "Settings", "XLFilename", txtXlFilename
    End If
    EnableControls True
End Sub

'tests the selected configurations agains the current Excel Settings
Private Sub RunPlot2CfgTestMCA()
    Dim i As Long
    Dim colPlot2Cfg As New Collection
    Dim bufferCFG As Variant
    Dim iSizeCFG As ArrayIndex                 '
    
    EnableControls False
    bufferCFG = LoadSpectrumCFG(txtXlFilename, txtCfgFilename, txtCfgDescription)
    iSizeCFG = GetArrayIndex(bufferCFG)
    DppDevice = GetDPPTypeFromString(CStr(bufferCFG(iSizeCFG.idxU)))
    For i = iSizeCFG.idxL To iSizeCFG.idxU
        colPlot2Cfg.Add bufferCFG(i)
    Next
    CreateCfgDir
    TestCfgFromXLSettings colPlot2Cfg
    pnlStatus = "MCA Dpp configurations testing done."
    Refresh
    EnableControls True
End Sub

'tests the selected configurations agains the current Excel Settings
Private Sub RunXLCfgTest()
    Dim i As Long
    Dim j As Long
    Dim colXLCfg As Collection
    Dim colXLCfgCol As New Collection
    Dim bRes As Boolean
    
    EnableControls False
    bRes = OpenWorkSheet(Trim(txtXlFilename))

    If (xlAppCls1 Is Nothing) Then Exit Sub
    'check for ini file exit if missing
    
    'get the xl configuration settings for selected columns
    For j = Val(txtXLStartCol) To Val(txtXLEndCol)
        Refresh
        pnlStatus = "Reading configuration in column " & j & "."
        Refresh
        Set colXLCfg = New Collection
        For i = 1 To 31
            colXLCfg.Add xlAppCls1.GetCellValue(i, j)
        Next
        colXLCfgCol.Add colXLCfg
    Next
    QuitWorkbook            'close xl
    CreateCfgDir
    Set colXLCfg = Nothing
    txtXLTestResults = ""
    For Each colXLCfg In colXLCfgCol
        Refresh
        If (colXLCfg.Count > 3) Then
            pnlStatus = "Testing configuration  " & colXLCfg.Item(2) & "."
        End If
        Refresh
        TestCfgFromXLSettings colXLCfg, True
    Next
    pnlStatus = "Excel spreadsheet configurations testing done."
    Refresh
    EnableControls True
End Sub

'displays the configuration test results
Private Sub DispXLTestStat(strStatus As String)
    txtXLTestResults = txtXLTestResults & strStatus & vbNewLine
End Sub

'tests if a file exists
Public Function FileExists(ByVal strFilename As String) As Boolean
    Dim strFile As String
    On Error Resume Next
    strFile = Trim(strFilename)         'trim whitespace
    If (Err Or (Len(strFile) = 0)) Then 'no filename, don't do test
        FileExists = False
        Exit Function
    End If
    If ((Mid(strFile, 1, 1) = """") And (Right(strFile, 1) = """")) Then 'Remove quotes
        If (Len(strFile) > 2) Then      'quoted string, remove quotes
            strFile = Mid(strFile, 2, Len(strFile) - 2)
        Else                            'quoted empty string, exit before dir test
            FileExists = False
            Exit Function
        End If
    End If
    strFile = Dir(strFile)
    If (Err) Then                       'could be bad chars etc
        FileExists = False
    Else
        FileExists = (strFile <> "")
    End If
End Function

'runs a configuration test for a given Excel setting
Private Sub TestCfgFromXLSettings(colPlot2Cfg As Collection, Optional isXL As Boolean = False)
    Dim cboIdx As Long
    Dim strSetting As String
    Dim strXLValue As String
    Dim strFilename As String
    Dim strDescription As String
    Dim cfgIndex As Integer
    Dim cfgIndexOffset As Integer
    Dim lenFilename As Long
    Dim strDefaultCfg As String
    Dim CurDppDevice As Integer
    Dim strDeviceType As String
    Dim isError As Boolean
    Dim colCfg As Collection
    Dim dblValue As Double
    Dim i As Integer
    Dim strDPPDevice As String

    isError = False
    If (colPlot2Cfg.Count <> 31) Then
        DispXLTestStat "XL Configuration Error, number settings incorrect."
        DispXLTestStat "<<<TEST FAIL>>>"
        Exit Sub
    End If
    strDefaultCfg = App.path & "\DPP.cfg"
    strDPPDevice = UCase(Trim(colPlot2Cfg(31)))
    CurDppDevice = GetDPPTypeFromString(strDPPDevice)
    If (CurDppDevice = 0) Then Exit Sub
    ConfigLoadFromFile CurDppDevice, App.path & "\dpp.cfg"
    frmCfgDlg.LoadTempConfig
    cfgIndex = 1  'starting configuration collection  index
    
    '--- Configuration Filename --------------------------------------------
    If (Len(Trim(colPlot2Cfg(cfgIndex))) = 0) Then Exit Sub
    strFilename = "DET_CFG\" & Trim(colPlot2Cfg(cfgIndex)) & ".cfg"
    DispXLTestStat "----------------------------"
    DispXLTestStat strFilename & " file tests..."
    DispXLTestStat strDeviceType

    cfgIndex = cfgIndex + 1

    '--- Configuration Description -----------------------------------------
    strDescription = colPlot2Cfg(cfgIndex)
    cfgIndex = cfgIndex + 1

    'check if file exists
    If Not FileExists(App.path & "\" & strFilename) Then
        DispXLTestStat strFilename & " File not found."
        DispXLTestStat "<<<TEST FAIL>>>"
        Exit Sub
    End If
    
    'check for entries in ini file
    strSetting = GetDetIniEntry(strDescription, "ERROR")
    If (strSetting = "ERROR") Then
        DispXLTestStat "INI file entry not found."
        isError = True
    ElseIf (strSetting <> strFilename) Then
        DispXLTestStat "INI file entry match error."
        isError = True
    End If
 
    Set colCfg = LoadCfgFromFile(App.path & "\" & strFilename, CByte(CurDppDevice))  'load cfg file values
    If (colCfg.Count <> 28) Then
        DispXLTestStat "Configuration file data error."
        DispXLTestStat "<<<TEST FAIL>>>"
        Exit Sub
    End If
     
    cfgIndexOffset = 0
    For i = 1 To colCfg.Count
        cfgIndex = i + 2
        If (i >= 11) Then
            cfgIndexOffset = 2
        End If
        strXLValue = GetMCACfgEntryValue(cfgIndex, colPlot2Cfg(cfgIndex), isXL)
        If ((CurDppDevice = 0) And (cfgIndex = xlcfgCoarse_Gain)) Then
            dblValue = atof(strXLValue)
            strXLValue = Format(dblValue, "0") & "x"
        End If
        If ((i + cfgIndexOffset) <= colCfg.Count) Then
            strSetting = CfgCompare(strXLValue, colCfg(i + cfgIndexOffset), cfgIndex)
            If (Len(strSetting) > 0) Then
                DispXLTestStat strSetting
                isError = True
            End If
        End If
    Next
    
    If (isError) Then
        DispXLTestStat "<<<TEST FAIL>>>"
    Else
        DispXLTestStat "+++TEST PASS+++"
    End If
End Sub

Public Function GetMCACfgEntryValue(Index As Integer, strValue As String, Optional isXL As Boolean = False) As String
    Dim dblValue As Double
    Dim strNewValue As String
    Dim strPercent As String
    
    Select Case Index
        Case xlcfgNone
            GetMCACfgEntryValue = strValue
        Case xlcfgFilename
            GetMCACfgEntryValue = strValue
        Case xlcfgDescription
            GetMCACfgEntryValue = strValue
        Case xlcfgCurrent_COM_Port
            GetMCACfgEntryValue = strValue
        Case xlcfgRise
            GetMCACfgEntryValue = strValue
        Case xlcfgTop
            GetMCACfgEntryValue = strValue
        Case xlcfgFastChThreshold
            GetMCACfgEntryValue = strValue
        Case xlcfgPUR_Enable
            GetMCACfgEntryValue = "PUR" & strValue
        Case xlcfgRTD_ON_OFF
            GetMCACfgEntryValue = "RTD" & strValue
        Case xlcfgRTD_threshold
            If (DppDevice = DPPDP5) Then
                strPercent = GetXLPercentDoubleStr(strValue)
                dblValue = atof(strPercent)
                strNewValue = Format(dblValue, "0.0") & "%"
                GetMCACfgEntryValue = strNewValue
            Else
                strPercent = GetXLPercentDoubleStr(strValue)
                dblValue = atof(strPercent)
                strNewValue = Format(dblValue, "0.00") & "% FS"
                GetMCACfgEntryValue = strNewValue
            End If
        Case xlcfgRTD_Fast_HWHM
            If (DppDevice = DPPDP5) Then
                strPercent = GetXLPercentDoubleStr(strValue)
                dblValue = atof(strPercent)
                strNewValue = Format(dblValue, "0") & "% FS"
                GetMCACfgEntryValue = strNewValue
            Else
                GetMCACfgEntryValue = strValue
            End If
        Case xlcfgAutoBaseline
            GetMCACfgEntryValue = strValue
        Case xlcfgBLR
            GetMCACfgEntryValue = GetBLRStrFromXLStr(strValue)
        Case xlcfgMCA_Channels
            GetMCACfgEntryValue = strValue
        Case xlcfgSlowChThreshold
            strPercent = GetXLPercentDoubleStr(strValue)
            dblValue = atof(strPercent)
            strNewValue = Format(dblValue, "0.00") & "% FS"
            GetMCACfgEntryValue = strNewValue
        Case xlcfgBuffer_Select
            GetMCACfgEntryValue = strValue
        Case xlcfgGate_Input_TTL
            GetMCACfgEntryValue = strValue
        Case xlcfgPreset
            GetMCACfgEntryValue = strValue
        Case xlcfgCoarse_Gain
            dblValue = atof(strValue)
            strNewValue = Format(dblValue, "0.00") & "x"
            GetMCACfgEntryValue = strNewValue
        Case xlcfgFine_Gain
            dblValue = atof(strValue)
            strNewValue = Format(dblValue, "0.0000")
            GetMCACfgEntryValue = strNewValue
        Case xlcfgInput_Polarity
            GetMCACfgEntryValue = strValue
        Case xlcfgInputOffset
            GetMCACfgEntryValue = strValue
        Case xlcfgPoleZero
            If (InStr(1, strValue, "off", vbTextCompare) > 0) Then
                GetMCACfgEntryValue = "OFF"
            Else
                GetMCACfgEntryValue = strValue
            End If
        Case xlcfgDet_Rst_Lockout
            If (InStr(1, strValue, "off", vbTextCompare) > 0) Then
                GetMCACfgEntryValue = "OFF"
            Else
                GetMCACfgEntryValue = strValue
            End If
        Case xlcfgTEC
            dblValue = atof(strValue)
            strNewValue = Format(dblValue, "0.0") & "K"
            GetMCACfgEntryValue = strNewValue
        Case xlcfgHV
            dblValue = atof(strValue)
            strNewValue = Format(dblValue, "0.0") & "V"
            GetMCACfgEntryValue = strNewValue
        Case xlcfgPreamp_Power
            GetMCACfgEntryValue = strValue
        Case xlcfgAnalog_Out
            GetMCACfgEntryValue = strValue
        Case xlcfgOutputOffset
            GetMCACfgEntryValue = strValue
        Case xlcfgAux
            GetMCACfgEntryValue = strValue
        Case xlcfgAudio
            GetMCACfgEntryValue = strValue
        Case Else
    End Select
End Function

'compare two config strings, return empty string if equal, show errors if not equal
Private Function CfgCompare(strCfg1 As String, strCfg2 As String, ByRef XLIndex As Integer) As String
    CfgCompare = ""
    If (Trim(strCfg1) <> Trim(strCfg2)) Then
        CfgCompare = GetXLCfgEntryLabel(XLIndex) & " value error. " & strCfg1 & " != " & strCfg2
    End If
End Function

'read a selected detector ini file entry
Private Function GetDetIniEntry(strKey As String, strData As String) As String
    Dim iniFile As String
    Dim Section As String
    iniFile = App.path & "\DET_CFG\AmptekDC.ini"
    Section = "Amptek Detector Configurations"
    GetDetIniEntry = GetFromIniEx(iniFile, Section, strKey, strData)
End Function

'create a configuration file index table from the AmptekDC.ini file
Public Sub GetCfgListFromIni()
    Dim varAllIni As Variant
    Dim i As Integer
    Dim j As Integer
    Dim idxLRec As Long
    Dim idxLFld As Long
    Dim idxURec As Long
    Dim idxUFld As Long
    
    Set colCfgFile = New Collection
    Set colCfgDesc = New Collection
    varAllIni = GetAllIniSettings("Amptek Detector Configurations")
    If IsEmpty(varAllIni) Then Exit Sub
    idxLRec = LBound(varAllIni, 1)
    idxLFld = LBound(varAllIni, 2)
    idxURec = UBound(varAllIni, 1)
    idxUFld = UBound(varAllIni, 2)
    For i = idxLRec To idxURec
         colCfgFile.Add varAllIni(i, 1)
         colCfgDesc.Add varAllIni(i, 0)
    Next
End Sub

'load a configuration from file load into a test Excel Collection
Private Function LoadCfgFromFile(strFilename As String, DppDeviceType As Byte) As Collection
    Dim strDisplay As String * 2000
    Dim strList As String
    Dim strCfg As String
    Dim i As Integer
    Dim colCfg As New Collection
    Dim lenFilename As Long
    If (objDppApi = 0) Then Exit Function       'exit sub if api is not present
    lenFilename = Len(strFilename)
    GetConfigFromFile objDppApi, strFilename, lenFilename, DppDeviceType
    GetConfigString objDppApi, strDisplay, 2000
    strCfg = ""
    strList = strDisplay
    For i = 1 To 28
        colCfg.Add GetNextCfgRecord(strList)
    Next
    Set LoadCfgFromFile = colCfg
End Function

'get record (goto end of line),get field name,get field value,assign to var
Private Function GetNextCfgRecord(ByRef strList As String) As Variant
    On Error Resume Next
    Dim strListTemp As String
    Dim strRecord As String
    Dim strVal As String
    Dim RecEnd As Long
    Dim ValPos As Long
    Dim varVal As Variant

    strListTemp = strList   'make copy of list
    RecEnd = InStr(1, strList, vbNewLine, vbTextCompare)
    If (RecEnd > 0) Then
        strRecord = Trim(Left(strList, RecEnd - 1))
        strListTemp = Trim(Mid(strList, RecEnd + 2))
    Else
        strRecord = Trim(strList)
        strListTemp = ""
    End If
    ValPos = InStr(1, strRecord, ":", vbTextCompare)
    If (ValPos > 0) Then
        varVal = Trim(Mid(strRecord, ValPos + 1))
    Else
        varVal = ""
    End If
    strList = strListTemp
    GetNextCfgRecord = varVal
End Function

