VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "comctl32.ocx"
Begin VB.Form frmCfgEdit 
   Caption         =   "DPP Configuration Editor"
   ClientHeight    =   8385
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8280
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   8385
   ScaleWidth      =   8280
   StartUpPosition =   2  'CenterScreen
   Begin VB.Frame fraFPGAClock 
      Caption         =   "FPGA Clock"
      Height          =   615
      Left            =   240
      TabIndex        =   15
      Top             =   960
      Visible         =   0   'False
      Width           =   2655
      Begin VB.OptionButton optFPGAClock 
         Caption         =   "80MHz"
         Height          =   255
         Index           =   1
         Left            =   1440
         TabIndex        =   17
         Top             =   240
         Width           =   975
      End
      Begin VB.OptionButton optFPGAClock 
         Caption         =   "20MHz"
         Height          =   255
         Index           =   0
         Left            =   240
         TabIndex        =   16
         Top             =   240
         Value           =   -1  'True
         Width           =   975
      End
   End
   Begin VB.Frame fraDPPDeviceType 
      Caption         =   "DPP Device Type"
      Height          =   615
      Left            =   60
      TabIndex        =   12
      Top             =   120
      Width           =   4695
      Begin VB.OptionButton OptDPPType 
         Caption         =   "PX4 Emulation"
         Height          =   255
         Index           =   3
         Left            =   3000
         TabIndex        =   14
         Top             =   240
         Value           =   -1  'True
         Width           =   1455
      End
      Begin VB.OptionButton OptDPPType 
         Caption         =   "DP4 Emulation"
         Height          =   255
         Index           =   2
         Left            =   1560
         TabIndex        =   13
         Top             =   240
         Width           =   1455
      End
      Begin VB.OptionButton OptDPPType 
         Caption         =   "PX4"
         Height          =   255
         Index           =   1
         Left            =   840
         TabIndex        =   10
         Top             =   240
         Width           =   615
      End
      Begin VB.OptionButton OptDPPType 
         Caption         =   "DP4"
         Height          =   255
         Index           =   0
         Left            =   120
         TabIndex        =   9
         Top             =   240
         Width           =   615
      End
   End
   Begin VB.CommandButton cmdDataAcqGetDPPStatus 
      Caption         =   "Get DPP Status"
      Height          =   375
      Left            =   720
      TabIndex        =   5
      Top             =   7560
      Width           =   1455
   End
   Begin VB.CommandButton cmdConfigCopyToClipBoard 
      Caption         =   "Copy Configuration To Clipboard"
      Height          =   375
      Left            =   4800
      TabIndex        =   6
      Top             =   240
      Width           =   2775
   End
   Begin VB.CommandButton cmdConfigSendConfig 
      Caption         =   "Send Configuration To DPP <--"
      Height          =   375
      Left            =   240
      TabIndex        =   3
      Top             =   3720
      Width           =   2655
   End
   Begin VB.CommandButton cmdConfigLoadFromHardware 
      Caption         =   "Load Configuration From DPP -->"
      Height          =   375
      Left            =   240
      TabIndex        =   1
      Top             =   2400
      Width           =   2655
   End
   Begin VB.CommandButton cmdConfigLoadFromFile 
      Caption         =   "Load Configuration From File -->"
      Height          =   375
      Left            =   240
      TabIndex        =   0
      Top             =   1920
      Width           =   2655
   End
   Begin VB.CommandButton cmdConfigSaveToFile 
      Caption         =   "Save Configuration To File <--"
      Height          =   375
      Left            =   240
      TabIndex        =   2
      Top             =   3240
      Width           =   2655
   End
   Begin VB.CommandButton cmdShowConfigDialog 
      Caption         =   "Edit Configuration"
      Height          =   375
      Left            =   4440
      TabIndex        =   8
      Top             =   7560
      Width           =   2415
   End
   Begin VB.TextBox txtConfig 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   6615
      Left            =   3120
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   7
      Top             =   840
      Width           =   5055
   End
   Begin ComctlLib.StatusBar StatusBar1 
      Align           =   2  'Align Bottom
      Height          =   375
      Left            =   0
      TabIndex        =   11
      Top             =   8010
      Width           =   8280
      _ExtentX        =   14605
      _ExtentY        =   661
      SimpleText      =   ""
      _Version        =   327682
      BeginProperty Panels {0713E89E-850A-101B-AFC0-4210102A8DA7} 
         NumPanels       =   1
         BeginProperty Panel1 {0713E89F-850A-101B-AFC0-4210102A8DA7} 
            AutoSize        =   1
            Object.Width           =   14076
            TextSave        =   ""
            Key             =   ""
            Object.Tag             =   ""
         EndProperty
      EndProperty
   End
   Begin VB.TextBox txtStatus 
      Height          =   2925
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   4
      Top             =   4560
      Width           =   2895
   End
   Begin MSComDlg.CommonDialog cmnDlg 
      Left            =   120
      Top             =   3840
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
End
Attribute VB_Name = "frmCfgEdit"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public pnlStatus As Panel               'status display panel

'opens then configuration dialog
Private Sub cmdShowConfigDialog_Click()
    cmdShowConfigDialog.Enabled = False
    If (objDppApi > 0) Then
        CfgEditUpdatesDone = False
        Load frmCfgDlg
        Set frmCfgDlg.DataAcqTimer = Nothing
        frmCfgDlg.Show vbModal
        If (CfgEditUpdatesDone) Then
            UpdateConfigDisplay
            pnlStatus = "Configuration edit done. Please save your changes."
        Else
            pnlStatus = "No configuration changes were made during edit session."
        End If
    End If
    cmdShowConfigDialog.Enabled = True
End Sub

'initializes controls before the form is loaded
Private Sub Form_Initialize()
    InitCommonControls          'load the common control DLL
End Sub

'initializes controls when the form is loaded
Private Sub Form_Load()
    Set pnlStatus = StatusBar1.Panels(1)        'set status display panel
    HasPlotCursorSupport = False                'turns off cursor support in config dialog
    pnlStatus = "Creating DppApi Interface..."  'display status
    DppDevice = GetSetting(App.EXEName, "Settings", "DPPDeviceType", 1) 'set the global device type to the last dpp device type selected
    If (DppDevice > DPPPX4) Then
        fraFPGAClock.Visible = True
    Else
        fraFPGAClock.Visible = False
    End If
    Dpp80MHzMode = GetSetting(App.EXEName, "Settings", "Dpp80MHzMode", 0)
    If ((DppDevice > DPPDP5) Or (DppDevice < DPPDP4)) Then DppDevice = 2
    DppFirmwareRev = 4                          'set default firmware rev
    DppFPGARev = 4                              'set default fpga rev
    OptDPPType(DppDevice - 1).value = True          'set the device type
    optFPGAClock(Dpp80MHzMode).value = True
    objDppApi = 0                               'set the dppapi pointer to null
    SetAPIBusyFlag False                        'clear the dppapi busy flag
    EnableControls False                        'disable api controls until ready
    ChDir App.path                              'set the default dir to the app path
    objDppApi = OpenDppApi()                    'create DppApi Object
    If (objDppApi > 0) Then                     'enable the load cfg controls if ready
        EnableLoadControls True
    Else                                        'else quit the application on dppapi error
        pnlStatus = "DppApi Interface error."
        MsgBox "DppApi Interface error." & vbNewLine & "The application must close.", vbCritical
        End
    End If
    Sleep (1000)
    pnlStatus = "Ready to load a configuration."
End Sub

'enables/disables configuration controls
Private Sub EnableControls(bEnable As Boolean)
    cmdConfigSaveToFile.Enabled = bEnable
    cmdConfigLoadFromFile.Enabled = bEnable
    cmdConfigLoadFromHardware.Enabled = bEnable
    cmdConfigSendConfig.Enabled = bEnable
    cmdConfigCopyToClipBoard.Enabled = bEnable
    cmdShowConfigDialog.Enabled = bEnable
End Sub

'enables/disables load configuration controls (used at startup)
Private Sub EnableLoadControls(bEnable As Boolean)
    cmdConfigLoadFromFile.Enabled = bEnable
    cmdConfigLoadFromHardware.Enabled = bEnable
    cmdDataAcqGetDPPStatus.Enabled = bEnable
End Sub

'closes the dppapi and unloads this form
Private Sub Form_Unload(Cancel As Integer)
    CloseDppApi (objDppApi)
    objDppApi = 0
    pnlStatus = "Dpp Connection Closed"
    EnableControls False
    Unload Me
    End
End Sub

'copies the current configuration to the clipboard
Private Sub cmdConfigCopyToClipBoard_Click()
    Dim strDisplay As String * 2000
    If (objDppApi = 0) Then Exit Sub            'only run if api is already running
    GetConfigString objDppApi, strDisplay, 2000
    Clipboard.Clear
    Clipboard.SetText strDisplay
    pnlStatus = "Configuration copied to clipboard."
End Sub

'loads a configuration form file
Private Sub cmdConfigLoadFromFile_Click()
    Dim strFileName As String
    Dim lenFilename As Long
    Dim DppDeviceType As Byte
    If (objDppApi = 0) Then Exit Sub            'exit sub if api is not present
    If (dlgOpen(cmnDlg, dlgCFG_Filter)) Then
        strFileName = cmnDlg.filename
        lenFilename = Len(strFileName)
        DppDeviceType = GetOption(OptDPPType) + 1
        If (DppDeviceType > DPPPX4) Then
            fraFPGAClock.Visible = True
        Else
            fraFPGAClock.Visible = False
        End If
        If ((DppDeviceType = DPPDP4EMUL) Or (DppDeviceType = DPPDP5)) Then
            Dpp80MHzMode = GetOption(optFPGAClock)
            SetFPGAClockDefault objDppApi, Dpp80MHzMode, DppDeviceType
        End If
        GetConfigFromFile objDppApi, strFileName, lenFilename, DppDeviceType
        UpdateConfigDisplay
        EnableControls True
        pnlStatus = "Configuration loaded from file."
    Else
        pnlStatus = "File load cancelled."
    End If
End Sub

'loads a configuration from hardware
Private Sub cmdConfigLoadFromHardware_Click()
    Dim strConfig As String
    Dim NumDevices As Integer
    Dim StatusLst As DPP_STATUS                 'holds copy of current status
    Dim Result As Boolean
    
    If (objDppApi = 0) Then Exit Sub            'exit sub if api is not present
    NumDevices = MonitorUSBDppDevices(objDppApi)
    If (NumDevices < 1) Then
        pnlStatus = "No USB devices found. No configuration loaded."
        Exit Sub           'exit if no dpp devices
    End If
    Result = VBGetDppStatus(objDppApi, StatusLst)
    If (StatusLst.SerialNumber < 1) Then
        pnlStatus = "Could not verify DPP status.  No configuration loaded."
        Exit Sub
    End If
    If ((DppDevice > DPPNONE) And (DppDevice <= DPPDP5)) Then
        If (DppDevice > DPPPX4) Then
            fraFPGAClock.Visible = True
        Else
            fraFPGAClock.Visible = False
        End If
        OptDPPType(DppDevice - 1).value = True
        'Run GetStatusStruct or GetStatusString before running Get80MHzMode
        Dpp80MHzMode = CInt(Get80MHzMode(objDppApi))
        optFPGAClock(Dpp80MHzMode).value = True
    End If
    GetConfigFromDpp objDppApi
    UpdateConfigDisplay
    strConfig = Trim(txtConfig)
    If (Len(strConfig) > 0) Then EnableControls True
    pnlStatus = "Configuration loaded from DPP."
End Sub

'saves a configuration to file
Private Sub cmdConfigSaveToFile_Click()
    Dim strFileName As String
    Dim lenFilename As Long
    
    If (objDppApi = 0) Then Exit Sub            'exit sub if api is not present
    If (dlgSave(cmnDlg, dlgCFG_Filter)) Then
        strFileName = cmnDlg.filename
        lenFilename = Len(strFileName)
        SaveConfigToFile objDppApi, strFileName, lenFilename
        pnlStatus = "Configuration saved to file."
    Else
        pnlStatus = "File save cancelled."
    End If
End Sub

'sends the current configuration to the dpp
Private Sub cmdConfigSendConfig_Click()
    If (objDppApi = 0) Then Exit Sub            'exit sub if api is not present
    Dim cmdEn As Boolean
    cmdEn = cmdConfigSendConfig.Enabled
    cmdConfigSendConfig.Enabled = False
    Dim AcqEn As Boolean
    SendConfigToDpp objDppApi
    cmdConfigSendConfig.Enabled = cmdEn
    pnlStatus = "Configuration sent to DPP."
End Sub

'updates the configuration display with the current configuration stored in the dppapi
Private Sub UpdateConfigDisplay()
    Dim strDisplay As String * 2000
    If (objDppApi = 0) Then Exit Sub            'only run if api is already running
    GetConfigString objDppApi, strDisplay, 2000
    txtConfig = TR(strDisplay, 20)
End Sub

'updates the status display with the current status
Private Sub cmdDataAcqGetDPPStatus_Click()
    Dim StatusLst As DPP_STATUS                 'holds copy of current status
    Dim Result As Boolean
    Result = VBGetDppStatus(objDppApi, StatusLst)
End Sub

'option buttons select the current device type
Private Sub OptDPPType_Click(Index As Integer)
    Dim strDppType As String
    SaveSetting App.EXEName, "Settings", "DPPDeviceType", (Index + 1)
    strDppType = DPPTypeString(Index + 1) & " Device Type Selected"
    If ((GetOption(OptDPPType) + 1) > DPPPX4) Then
        fraFPGAClock.Visible = True
    Else
        fraFPGAClock.Visible = False
    End If
End Sub

'option buttons select the fpga clock for file cfg
Private Sub optFPGAClock_Click(Index As Integer)
    SaveSetting App.EXEName, "Settings", "Dpp80MHzMode", Index
End Sub

'holds the status data structure
Private Function VBGetDppStatus(objDppApi As Long, ByRef StatusStruct As DPP_STATUS) As Boolean
    Dim varTemp As Variant
    Dim i As Integer
    Dim strList As String
    Dim strDeviceType As String

    VBGetDppStatus = False
    If (objDppApi = 0) Then Exit Function       'only run if api is already running
    GetStatusStruct objDppApi, 1, StatusStruct
    If (StatusStruct.SerialNumber < 1) Then Exit Function
    DppDevice = DPPTypeFromStatus(StatusStruct) 'DPP5 20071023
    strDeviceType = DPPTypeString(DppDevice)
    
    DppFirmwareRev = StatusStruct.Firmware
    DppFPGARev = StatusStruct.FPGA

    strList = ""
    strList = strList & "Device Type = " & strDeviceType & vbNewLine
    strList = strList & "Fast Count = " & StatusStruct.FastCount & vbNewLine
    strList = strList & "Slow Count = " & StatusStruct.SlowCount & vbNewLine
    strList = strList & "FPGA = " & Format(StatusStruct.FPGA, "0.00") & vbNewLine
    strList = strList & "Firmware = " & Format(StatusStruct.Firmware, "0.00") & vbNewLine
    strList = strList & "Serial Number = " & Format(CLng(StatusStruct.SerialNumber), "0000") & vbNewLine
    strList = strList & "Accumulation Time = " & StatusStruct.AccumulationTime & vbNewLine
    strList = strList & "StatMcaEnabled = " & CBool(StatusStruct.StatMcaEnabled) & vbNewLine
    txtStatus = strList
    pnlStatus = "Current DPP status displayed."
    VBGetDppStatus = True
End Function

Public Function GetOption(opts As Object) As Integer
    On Error GoTo GetOptionErr
    Dim opt As OptionButton
    For Each opt In opts
        If opt.value Then
            GetOption = opt.Index
            Exit Function
        End If
    Next
GetOptionErr:
    GetOption = -1
End Function
